VERSION 2.00
Begin Form Form1 
   Caption         =   "Click Me For Drive Statistics"
   ClientHeight    =   5550
   ClientLeft      =   1860
   ClientTop       =   1830
   ClientWidth     =   9375
   Height          =   5955
   Left            =   1800
   LinkTopic       =   "Form1"
   ScaleHeight     =   5550
   ScaleWidth      =   9375
   Top             =   1485
   Width           =   9495
End
Option Explicit

' API Declarations
Declare Function Declare32 Lib "call32.dll" (ByVal Func As String, ByVal Library As String, ByVal Args As String) As Long
Declare Function GetDiskFreeSpace Lib "call32.dll" Alias "Call32" (ByVal lpRootPathname As String, lpSectorsPerCluster As Long, lpBytesPerSector As Long, lpNumberOfFreeClusters As Long, lpTotalNumberOfClusters As Long, ByVal id As Long) As Long
Declare Function GetDriveType Lib "call32.dll" Alias "Call32" (ByVal lpRootPathname As String, ByVal id As Long) As Long

' GetDriveType return values
Const DRIVE_UNKNOWN = 0
Const DRIVE_NOTPRESENT = 1
Const DRIVE_REMOVABLE = 2
Const DRIVE_FIXED = 3
Const DRIVE_REMOTE = 4
Const DRIVE_CDROM = 5
Const DRIVE_RAMDISK = 6

' Module-level ID variable for each Win32 API
Dim idFreeSpace As Long
Dim idDriveType As Long

Sub Form_Click ()
   Dim i&
   Dim drv$
   Dim dType&
   Dim dfsSectorsPerCluster&
   Dim dfsBytesPerSector&
   Dim dfsFreeClusters&
   Dim dfsTotalClusters&
   Dim FreeSpace&
   Dim TotalSpace&
   '
   ' Clear the form, and loop through the alphabet.
   '
   Me.Cls
   For i = 65 To 90
      '
      ' Construct string used to identify root.
      '
      drv$ = Chr$(i) & ":\"
      Me.Print "  "; drv$,
      '
      ' Display type of drive for each letter.
      '
      dType = GetDriveType(drv$, idDriveType)
      Select Case dType
	 Case DRIVE_UNKNOWN
	    Me.Print "Cannot be determined."
	 Case DRIVE_NOTPRESENT
	    Me.Print "Root directory does not exist."
	 Case DRIVE_REMOVABLE
	    Me.Print "Can be removed from the drive.",
	 Case DRIVE_FIXED
	    Me.Print "Cannot be removed from the drive.",
	 Case DRIVE_REMOTE
	    Me.Print "Remote (network) drive.", ,
	 Case DRIVE_CDROM
	    Me.Print "CD-ROM drive.", ,
	 Case DRIVE_RAMDISK
	    Me.Print "RAM disk.", ,
      End Select
      '
      ' Get and display free/total space.
      '
      If dType > DRIVE_NOTPRESENT Then
	 If GetDiskFreeSpace(drv$, dfsSectorsPerCluster, dfsBytesPerSector, dfsFreeClusters, dfsTotalClusters, idFreeSpace) Then
	    FreeSpace = dfsBytesPerSector * dfsSectorsPerCluster * dfsFreeClusters
	    TotalSpace = dfsBytesPerSector * dfsSectorsPerCluster * dfsTotalClusters
	    Me.Print Format(FreeSpace, "#,##0"); "/"; Format(TotalSpace, "#,##0"); " Bytes Free";
	    Me.Print " ("; Format(FreeSpace / TotalSpace * 100, "0.0"); "%)"
	 Else
	    Me.Print "Media missing."
	 End If
      End If
   Next i
End Sub

Sub Form_Load ()
   '
   ' Obtain function ID's for Win32 calls
   '
   idFreeSpace = Declare32("GetDiskFreeSpaceA", "kernel32", "ppppp")
   idDriveType = Declare32("GetDriveTypeA", "kernel32", "p")
   '
   ' Size and position form.
   '
   Me.Height = (Me.Height - Me.ScaleHeight) + (Me.TextHeight("X") * 26)
   Me.Move (Screen.Width - Me.Width) \ 2, (Screen.Height - Me.Height) \ 2
End Sub

