Option Explicit

Declare Function GetVersion Lib "Kernel" () As Long
Declare Function GetWinFlags Lib "Kernel" () As Long
Declare Function GetFileVersionInfo Lib "VER.DLL" (ByVal lpszFileName$, ByVal handle As Any, ByVal cbBuf&, ByVal lpvData$) As Integer



Function ByteHi% (WordIn%)
   '
   ' Lop off low byte with divide. If less than
   ' zero, then account for sign bit (adding &h10000
   ' implicitly converts to Long before divide).
   '
   If WordIn < 0 Then
      ByteHi = (WordIn + &H10000) \ &H100
   Else
      ByteHi = WordIn \ &H100
   End If
End Function

Function ByteLo% (WordIn%)
   '
   ' Mask off high byte and return low.
   '
   ByteLo = WordIn And &HFF
End Function

Function IsWin95 () As Integer
   '
   ' Win95 returns 3.95 to Win16 apps because
   ' returning 4.0 broke too many of them!
   '
   If VerWin() = 395 Then
      IsWin95 = True
   Else
      IsWin95 = False
   End If
End Function

Function IsWinNT () As Integer
   Const WF_WINNT = &H4000
   '
   ' Use GetWinFlags to test for NT.
   '
   If GetWinFlags() And WF_WINNT Then
      IsWinNT = True
   Else
      IsWinNT = False
   End If
End Function

Function VerDos% ()
   Dim nRet%
   '
   ' Use GetVersion to find DOS version, which
   ' is byte-swapped in the high word of return.
   '
   nRet = WordHi(GetVersion())
   VerDos = ByteHi(nRet) * 100 + ByteLo(nRet)
End Function

Function VerWin% ()
   Dim nRet%
   Dim Ver$
   '
   ' Use GetVersion to find initial answer, which
   ' is byte-swapped in the low word of return.
   '
   nRet = WordLo(GetVersion())
   nRet = ByteLo(nRet) * 100 + ByteHi(nRet)
   '
   ' For "compatibility", v3.11 returns v3.10, check it.
   '
   If nRet = 310 Then
      Ver = Space$(255)
      nRet = GetFileVersionInfo("user.exe", 0&, Len(Ver), Ver)
      '
      ' Find position in Ver$ of "FileVersion" stamp.
      '
      nRet = InStr(1, Ver, "FileVersion")
      '
      ' Look just beyond stamp for version string.
      '
      If Mid$(Ver, nRet + 12, 4) = "3.11" Then
         VerWin = 311
      Else
         VerWin = 310
      End If
   Else
      VerWin = nRet
   End If
End Function

Function WordHi% (LongIn&)
   '
   ' Mask off low word then do integer divide to
   ' shift right by 16.
   '
   WordHi = (LongIn And &HFFFF0000) \ &H10000
End Function

Function WordLo% (LongIn&)
   '
   ' Low word retrieved by masking off high word.
   ' If low word is too large, twiddle sign bit.
   '
   If (LongIn And &HFFFF&) > &H7FFF Then
      WordLo = (LongIn And &HFFFF&) - &H10000
   Else
      WordLo = LongIn And &HFFFF&
   End If
End Function

